#! /bin/sh

MAKE="make"
if [ `uname -s` = SunOS ]; then
  MAKE="gnumake"
fi


# loads config file
if [ -f minisat-default ] ; then 
   . minisat-default
fi


# ----------------------------------------------------------------------
if [ ! -d ${minisat_dir} ] ; then 
   if [ ! -f ${minisat_zip} ] ; then
      echo Error: ${minisat_zip} not found
      exit 1
   fi

   unzip ${minisat_zip}

   if [ ! -d ${minisat_dir} ] ; then
      echo Error: not able to uncompress ${minisat_zip}
      exit 1
   fi
fi

if [ ! -d $minisat_dir ]; then 
echo "<$minisat_dir> directory was aspected to exist after unpacking $minisat_zip"
exit 1
fi


# applies the patch if needed
if [ ! -f patched ]; then
    patch -p0 -N < ${minisat_dir}_nusmv.patch && touch patched
fi


if [ ! -h ${minisat_link} ] ; then             
   ln -s `pwd`/${minisat_dir} ${minisat_link}
fi


# ----------------------------------------------------------------------
# Make invokation:
echo
echo "Building MiniSat using <$MAKE $*>..."
cd ${minisat_dir} && $MAKE $* lib
echo
# ----------------------------------------------------------------------
